{
Model 2 from the paper

Pascal program, code written by Michael Hochberg
in collaboration with Harvey Whitehouse in 2010 as part of the EXREL project.}

uses crt,dos;


const groups=10;  timespan=10;


var


pop:array[1..groups] of extended;
grp:array[1..groups,1..4] of integer;
deltC,deltS:array[1..groups,0..timespan] of integer;

margin,diffdelt,dontgo,p,i,j,countit,ext,
deltCtot,deltStot,
splinter,reform,temp,threshREF,threshSPL:integer;

change,t,fract,alpha,t1,constC,constS,pickit:extended;

socket,addcar,addstk:boolean;





procedure initial;

begin


{grp  1=freq, 2=stick, 3=carrot, 4=neutral}


constC:= 1.0;

constS:= 4.0;


diffdelt:= 2;

margin:= 2;


t1:= 0.2;


alpha:= 1.2;

fract:= 0.1;

dontgo:= 40;



splinter:= 1;

reform:= 1;

threshREF:= 2;

threshSPL:= 39;




for i:= 1 to groups do begin

for j:= 0 to timespan do begin

deltC[i,j]:= 0;
deltS[i,j]:= 0;

end;

pop[i]:= random(1000);

grp[i,1]:= 1+random(40);

grp[i,2]:= random(33);

grp[i,3]:= random(33);

grp[i,4]:= 100-grp[i,3]-grp[i,2];

end;


deltCtot:= 0;

deltStot:= 0;


end;



















procedure runnit;

begin

{grp  1=freq, 2=stick, 3=carrot, 4=neutral}


for i:= 1 to groups do begin


if pop[i]>0.0 then begin




{////////////////}

if grp[i,1] <= 20 then begin

   {ADD marker}

addcar:= false; addstk:= false;

   {HIGHER PROB AS FREQ GOES TO 1}

pickit:= random;

if (pickit < 1.0/(constC + grp[i,1])) then begin

if grp[i,4]>0 then begin

   {ADD CARROT}

grp[i,3]:= grp[i,3] + 1;

   {LOSE neutral}

grp[i,4]:= grp[i,4] - 1;

if grp[i,3]>100 then grp[i,3]:= 100;
if grp[i,4]<0 then grp[i,4]:= 0;

deltC[i,0]:=deltC[i,0]+1;

end;

end else begin

pickit:= random;

if (pickit < 1.0/(constS + grp[i,1])) then begin

   {ADD STICK}

if grp[i,4]>0 then begin

grp[i,2]:= grp[i,2] + 1;

   {LOSE neutral}

grp[i,4]:= grp[i,4] - 1;

if grp[i,2]>100 then grp[i,2]:= 100;
if grp[i,4]<0 then grp[i,4]:= 0;

deltS[i,0]:= deltS[i,0]+1;

end; end; end;

end; {freq<=20}



{////////////////}


if grp[i,1] > 20 then begin


pickit:= random;

   {MORE PROB AS FREQ GOES TO 40 BUT NEED CARROTS TO DO THIS}

if (pickit < grp[i,1]/40.0) and (grp[i,3]>0) then begin


if grp[i,3]>0 then begin

   {LOSE CARROT}

grp[i,3]:= grp[i,3] - 1;

if grp[i,3]<0 then grp[i,3]:= 0;

   {GAIN NEUTRAL}

grp[i,4]:= grp[i,4] + 1;

if grp[i,4]>100 then grp[i,4]:= 100;

deltC[i,0]:= deltC[i,0] - 1;

end; end; end;


end; end;

end;









Procedure FREQ;

begin

for i:= 1 to groups do begin

if pop[i]>0.0 then begin

   {CHANGE frequency}

deltStot:= 0;
for j:= 0 to 10 do begin
deltStot:= deltStot + deltS[i,j];
end;
deltCtot:= 0;
for j:= 0 to 10 do begin
deltCtot:= deltCtot + deltC[i,j];
end;



if deltStot  {-deltCtot} > diffdelt then begin

   {INCREASE FREQ IF STICK ADDED}

grp[i,1]:= grp[i,1] + 1;

if grp[i,1]>40 then grp[i,1]:= 40;

end;

   {IF NOTHING ADDED, THEN DECREASE}

if (abs(deltStot) <= margin) and (abs(deltCtot) <= margin)

then begin

grp[i,1]:= grp[i,1] - 1;

if grp[i,1] < 1 then grp[i,1]:= 1;

end;

end; end;
end;















procedure collapse;

begin

{grp  1=freq, 2=stick, 3=carrot, 4=neutral}


for i:= 1 to groups do begin


if pop[i]>0.0 then begin


socket:= false;

if (grp[i,2]<reform) or (grp[i,1]<threshREF) then begin

grp[i,1]:= 20;
{grp[i,2]:= random(33);
grp[i,3]:= random(33);
grp[i,4]:= 100-grp[i,2]-grp[i,3];}

if grp[i,4] > 0 then begin

temp:= round(t1*grp[i,4]);

grp[i,2]:= grp[i,2] + temp;
grp[i,4]:= grp[i,4] - temp;

end;

if grp[i,2]>100 then grp[i,2]:= 100;
if grp[i,4]<0 then grp[i,4]:= 0;

socket:= true;

end;


if (socket=false) and ((grp[i,3]<splinter) or (grp[i,1]>threshSPL)) then begin

grp[i,1]:= 20;
{grp[i,2]:= random(33);
grp[i,3]:= random(33);
grp[i,4]:= 100-grp[i,2]-grp[i,3];}


if grp[i,4] > 0 then begin

temp:= round(t1*grp[i,4]);

grp[i,3]:= grp[i,3] + temp;
grp[i,4]:= grp[i,4] - temp;

end;

if grp[i,3]>100 then grp[i,3]:= 100;
if grp[i,4]<0 then grp[i,4]:= 0;

end;          end;
end;


end;















procedure usurp;

begin

{grp  1=freq, 2=stick, 3=carrot, 4=neutral}



for i:= 1 to groups do begin


if (pop[i]>0.0) and (ext<groups-1) then begin


repeat

p:= 1+random(groups);

until (p<>i) and (pop[p]>0.0);

socket:= false;





if (grp[p,3] > round(alpha*grp[i,3])) and (grp[i,2] < dontgo) then begin

socket:=true;

change:= (fract*pop[i]);

pop[p]:= pop[p] + change;

pop[i]:= pop[i] - change;

if (grp[p,4]>0) and (pop[p]>0) then begin
grp[p,3]:= grp[p,3] + 1;
grp[p,4]:= grp[p,4] - 1;
if grp[p,3]>100 then grp[p,3]:= 100;
if grp[p,4]<0 then grp[p,4]:= 0;
end;

if (grp[i,4]>0) and (pop[i]>0) then begin
grp[i,2]:= grp[i,2] + 1;
grp[i,4]:= grp[i,4] - 1;
if grp[i,2]>100 then grp[i,2]:= 100;
if grp[i,4]<0 then grp[i,4]:= 0;
end;

end;



if (socket=false) and (grp[i,3] > round(alpha*grp[p,3])) and (grp[p,2] < dontgo) then begin

change:= (fract*pop[p]);

pop[i]:= pop[i] + change;

pop[p]:= pop[p] - change;

if (grp[i,4]>0) and (pop[i]>0) then begin
grp[i,3]:= grp[i,3] + 1;
grp[i,4]:= grp[i,4] - 1;
if grp[i,3]>100 then grp[i,3]:= 100;
if grp[i,4]<0 then grp[i,4]:= 0;
end;

if (grp[p,4]>0) and (pop[p]>0) then begin
grp[p,2]:= grp[p,2] + 1;
grp[p,4]:= grp[p,4] - 1;
if grp[p,2]>100 then grp[p,2]:= 100;
if grp[p,4]<0 then grp[p,4]:= 0;
end;

end;


if pop[i]<10.0 then begin pop[i]:= 0.0; ext:= ext+1; end;

if pop[p]<10.0 then begin pop[p]:= 0.0; ext:= ext+1; end;

end;

end;


end;














begin

randomize;


initial;


writeln;

ext:= 0;


t:= 0.0;

repeat

runnit;

collapse;

usurp;

freq;



for i:= 1 to groups do begin
if pop[i]>0.0 then begin
for j:= timespan downto 1 do begin

deltC[i,j]:= deltC[i,j-1];
deltS[i,j]:= deltS[i,j-1];

end;

deltC[i,0]:= 0;
deltS[i,0]:= 0;

end; end;




t:= t+1.0;
until (t=100000.0) or (ext=groups-1);



for i:= 1 to groups do begin

if pop[i]>0.0 then

writeln(pop[i]:11,' ',grp[i,1]:11,' ',grp[i,2]:11,' ',grp[i,3]:11,
        ' ',grp[i,4]:11);


end;


repeat until keypressed=true;

end.
